/*-----------------------------------------------------------------------------
[]	ShitarabianDoc.cpp
[Tv]	hLgNX̎
[l]	Ȃ
[]	2003-03-11	NC		Rgt	(moralog)
		2003-10-24	b031031 (3199)C		(dincom)
		2003-11-08	b031130	(3146)ǂݍݎAIvV𔽉f(moralog)
		2003-12-06	b031130 (3146)^OWv@\NAccessViolationC(moralog)
-----------------------------------------------------------------------------*/


//-----------------------------------------------------------------------------
// CN[h
//-----------------------------------------------------------------------------
#include "stdafx.h"
#include "Shitarabian.h"
#include "MainFrm.h"
#include "ShitarabianDoc.h"
#include "CommandDelete.h"
#include "CommandCaret.h"
#include "CommandManager.h"
#include "Selection.h"
#include "BoxSelection.h"
#include "ROISelection.h"
#include "FloatingSelection.h"
#include "ShitarabianView.h"
#include "Common.h"
#include "ShitarabianPlugInManager.h"
#include "DocumentIF.h"
#include "EditDrawer.h"
#include "Unicoder.h"
#include "ExeCommon.h"
#include "SettingPath.h"
#include "EmphasisLine.h"
#include "BackUp.h"
#include "CommandInput.h"
#include "CommandMultiEdit.h"
#include "Padding.h"
#include "EmphasisDefine.h"
#include "GeneralSetting.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CShitarabianDoc, CDocument)

BEGIN_MESSAGE_MAP(CShitarabianDoc, CDocument)
	//{{AFX_MSG_MAP(CShitarabianDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/*-----------------------------------------------------------------------------
[]	RXgN^
[@\]	CX^X̐B
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
CShitarabianDoc::CShitarabianDoc()
:	m_lststrEditz()
,	m_idxCaretRow( 0 )
,	m_idxCaretColumn( 0 )
,	m_bOverwrite( FALSE )
,	m_eMode( OperationNormal )
,	m_paIndex( NULL )
,	m_bModified( FALSE )
,	m_idxUpdateStartRow( -1 )
,	m_idxUpdateEndRow( -1 )
,	m_nMark( 0 )
,	m_pviewMain( NULL )
,	m_bNeedBackUp( FALSE )
{
	GetSelection()->Attach( this );
	GetBoxSelection()->Attach( this );
	GetFloatingSelection()->Attach( this );

	m_Interface.Attach( ::AfxGetInstanceHandle() );

	::SetDocument( this );
}


/*-----------------------------------------------------------------------------
[]	fXgN^
[@\]	CX^X̔jB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
CShitarabianDoc::~CShitarabianDoc()
{
	if ( m_paIndex != NULL )
	{
		delete m_paIndex;
		m_paIndex = NULL;
	}
}


/*-----------------------------------------------------------------------------
[]	uVKvnh
[@\]	VKhLg̏B
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
BOOL CShitarabianDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// eLXg̏
	m_lststrEditz.RemoveAll();
	CEmphasisLine NewLine;
	NewLine.SetString("");
	m_lststrEditz.AddTail( NewLine );
	m_bModified = TRUE;

	// Lbgʒȕ
	CCommandCaret	cmdCaret;
	cmdCaret.SetAttribute( 0x00, 0, 0 );
	cmdCaret.Execute( this );

	// Undo̔j
	CCommandManager::GetInstance()->RemoveAll();

	// IԂ̏
	GetSelection()->SetSelectedNutral();

	// ^Cg̐ݒ
	SetTitle( "" );

	// r[̏
	SetMainView( NULL );
	POSITION pos = GetFirstViewPosition();
	if ( pos != NULL )
	{
		SetMainView( (CShitarabianView*)GetNextView(pos) );
		GetMainView()->ResetHScroll();
		GetMainView()->ScrollToCaret();
	} 

	// XV񏉊
	SetModifiedFlag( FALSE );
	m_bNeedBackUp = FALSE;

	// XVʒm
	CShitarabianPlugInManager::GetInstance()->OnEdit(
		this
	);
	return TRUE;
}


/*-----------------------------------------------------------------------------
[]	ۑ
[@\]	hLg̏oB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CShitarabianDoc::Write(CArchive& ar)
{
	POSITION	pos;
	pos = m_lststrEditz.GetHeadPosition();
	while( pos != NULL )
	{
		CString&	strLine = *((m_lststrEditz.GetNext( pos )).GetString());
		ar.WriteString( strLine  );

		// ̍sȂs
		if( pos != NULL )
		{
			ar << (char)0x0D;
			ar << (char)0x0A;
		}
	}
}

/*-----------------------------------------------------------------------------
[]	VAC[[V
[@\]	hLg̓ǂݍ݁^oB
[ߒl]	Ȃ
[l]	CDocument::Serialize()̃wvQƁB
-----------------------------------------------------------------------------*/
void CShitarabianDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// o
		Write( ar );

		// XVԂ̏
		// DeModify() 
		for ( int idxLine=0 ; idxLine<GetLineCount() ; idxLine++ )
		{
			POSITION	pos;
			pos = GetPosition( idxLine );
			if( pos != NULL )
			{
				m_lststrEditz.GetAt( pos ).SetModify( FALSE );
			}
		}
		SetAllUpdate();
		ReDraw();
	}
	else
	{
	// ǂݍ

		// ҏWf[^̔j
		m_lststrEditz.RemoveAll();

		// gqɑΉݒǂݍ
		int	idxSeparater = ar.GetFile()->GetFileName().ReverseFind( '.' );
		if ( idxSeparater > -1 )
		{
			CString strExt = ar.GetFile()->GetFileName().Mid(
					idxSeparater+1
				);
			CSettingPath::GetInstance()->PrepareExtFolder( strExt );

			// DrawerɃtHgύXʒm
			CEditDrawer::GetInstance()->RecalcFontSize();

			// \F\z
			ReflectEmphasis();
		}

		while( 1 )
		{
			CString	strLine;
			BOOL bExists = ar.ReadString( strLine );

			if ( bExists )
			{
				CEmphasisLine	NewLine;
				NewLine.SetString( strLine );
				NewLine.SetModify( FALSE );
				m_lststrEditz.AddTail( NewLine );
			}
			else
			{
				// Ō̃f[^sł΁AŌsǉ
				char*	pstrCRLF = ReturnChar();
				DWORD	dwCRLFLength = strlen( pstrCRLF );

// please! ̕catchׂ
				CFile*	pFile = ar.GetFile();
				if ( pFile->GetLength() >= dwCRLFLength )
				{
					// Ō̉sɃV[N
					pFile->Seek( -(int)dwCRLFLength, CFile::end );

					// ǂݍł݂
					char*	pLastChar = new char [ dwCRLFLength ];
					pFile->Read( pLastChar, dwCRLFLength );

					// {ɉsł΁AŌ̍sǉ
					if ( 0 == memcmp( pLastChar, pstrCRLF, dwCRLFLength ) )
					{
						CEmphasisLine	NewLine;
						NewLine.SetString( "" );
						NewLine.SetModify( FALSE );
						m_lststrEditz.AddTail( NewLine );
					}

					delete [] pLastChar;
				}
				break;
			}
		}

		m_bModified = TRUE;

		// \F
		// xD悷邽߁As\F݂̉͂̂sA
		// ܂߂ȉ͕͂\ɂB
		AnalizeEmphasisLinez(
			0,
			GetLineCount()-1
		);

		// obNAbv쐬
		SetPathName( ar.GetFile()->GetFilePath() );
		CBackUp::GetInstance()->DocumentSave( this );
	}
}


//-----------------------------------------------------------------------------
// ff
//-----------------------------------------------------------------------------
#ifdef _DEBUG
void CShitarabianDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CShitarabianDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG


/*-----------------------------------------------------------------------------
[]	sʒu擾
[@\]	ws̃CfNXf[^𓾂B
[ߒl]	POSITION	sʒu [m_lststrEditz] (-)
[l]	Ȃ
-----------------------------------------------------------------------------*/
POSITION	CShitarabianDoc::GetPosition(
	long idxRow				// I  :s@[-] (-) :-
)
{
	if ( m_bModified )
	{
		// Kvł΍sCfNX\z
		PrepareIndex();
		m_bModified = FALSE;
	}

	if ( idxRow >= 0 )
	if ( m_paIndex != NULL )
	if ( idxRow < m_lststrEditz.GetCount() )
	{
		return( m_paIndex[ idxRow ] );
	}

	return( NULL );
}


/*-----------------------------------------------------------------------------
[]	s擾
[@\]	ws̕𓾂B
[ߒl]	CString*	s [-] (-)
[l]	Ȃ
-----------------------------------------------------------------------------*/
CString*	CShitarabianDoc::GetLine(
	long idxRow				// I  :s@[-] (-) :-
)
{
	POSITION	pos = NULL;
	pos = GetPosition( idxRow );

	if( pos != NULL )
	{
		CString*	pstrLine = m_lststrEditz.GetAt( pos ).GetString();
		return( pstrLine );
	}

	return( NULL );
}


/*-----------------------------------------------------------------------------
[]	Fts擾
[@\]	ws̏𓾂B
[ߒl]	CEmphasisLine*	Fts [-] (-)
[l]	Ȃ
-----------------------------------------------------------------------------*/
CEmphasisLine*	CShitarabianDoc::GetEmphasisLine(
	long idxRow
)
{
	POSITION	pos = NULL;
	pos = GetPosition( idxRow );

	if( pos != NULL )
	{
		CEmphasisLine&	Line = m_lststrEditz.GetAt( pos );
		return( &Line );
	}

	return( NULL );
}


/*-----------------------------------------------------------------------------
[]	s폜
[@\]	ws폜
[ߒl]	BOOL	 [-] (TRUE:AFALSE:s)
[l]	Ȃ
-----------------------------------------------------------------------------*/
BOOL	CShitarabianDoc::DeleteLine(
	long idxRow				// I  :s [-] (-) :-
)
{
	POSITION	pos;
	pos = GetPosition( idxRow );
	if( pos != NULL )
	{
		m_lststrEditz.RemoveAt( pos );
		m_bModified = TRUE;
		SetModifiedFlag( TRUE );
		m_bNeedBackUp = TRUE;
		return( TRUE );
	}

	return( FALSE );
}


/*-----------------------------------------------------------------------------
[]	͈͍s폜
[@\]	w͈͍s폜B
[ߒl]	BOOL	 [-] (TRUE:AFALSE:s)
[l]	Ȃ
-----------------------------------------------------------------------------*/
BOOL	CShitarabianDoc::DeleteLinez(
	long	idxStartRow,		// I  :Jns [-] (-) :-
	long	nRow				// I  :s [-] (-) :-
)
{
	// s̍폜
	{
		POSITION	pos;
		pos = GetPosition( idxStartRow );
		while( pos!=NULL && nRow>0 )
		{
			POSITION	posNext = pos;
			m_lststrEditz.GetNext( posNext );

			m_lststrEditz.RemoveAt( pos );
			m_bModified = TRUE;

			pos = posNext;
			nRow--;
		}
	}

	// s\F̍\z
	// O̍šJz擾A폜s̐擪ƍvȂΕ\F͏
	CEmphasisLine*	pPrevLine = GetEmphasisLine( idxStartRow );
	CEmphasisLine*	pNextLine = GetEmphasisLine( idxStartRow+1 );
	short	idxContinueEmphasis = EMPHASIS_TEXT;
	if ( pPrevLine != NULL )
	{
		idxContinueEmphasis = pPrevLine->GetEmphasisNextContinue();
	}
	if ( pNextLine != NULL )
	{
		if ( idxContinueEmphasis != pNextLine->GetEmphasisPrevRelation() )
		{
			// \F͏
			pNextLine->SetEmphasisPrevRelation( idxContinueEmphasis );
			pNextLine->SetMultiLineEmphasisAnalized( FALSE );
			pNextLine->ResetDetailEmphasis();
		}
	}

	SetModifiedFlag( TRUE );
	m_bNeedBackUp = TRUE;
	return( TRUE );
}


/*-----------------------------------------------------------------------------
[]	sQ}
[@\]	sQ}B
[ߒl]	BOOL	 [-] (TRUE:AFALSE:s)
[l]	Ȃ
-----------------------------------------------------------------------------*/
BOOL	CShitarabianDoc::InsertLinez(
	long idxRow,
	CStringList& lstAddz
)
{
	POSITION	posDst;
	posDst = GetPosition( idxRow );

	POSITION	posSrc;
	posSrc = lstAddz.GetHeadPosition();

	if( posDst == NULL )
	{
		// ̖ɒǉ
		while( posSrc != NULL )
		{
			InsertLine(
				NULL,
				lstAddz.GetNext( posSrc )
			);
		}
	}
	else
	{
		// ̓rɑ}
		while( posSrc != NULL )
		{
			InsertLine(
				posDst,
				lstAddz.GetNext( posSrc )
			);
		}
	}

	// XVݒ
	m_bModified = TRUE;
	SetModifiedFlag( TRUE );
	m_bNeedBackUp = TRUE;

	// \F
	for( int idxLine=0 ; idxLine<lstAddz.GetCount() ; idxLine++ )
	{
		AnalizeMultiLineEmphasis(
			CGeneralSetting::GetInstance()->GetEmphasisDefine(),
			idxRow + idxLine
		);
	}

	return( TRUE );
}


/*-----------------------------------------------------------------------------
[]	s}
[@\]	s}B
[ߒl]	BOOL	 [-] (TRUE:AFALSE:s)
[l]	Ȃ
-----------------------------------------------------------------------------*/
BOOL	CShitarabianDoc::InsertLine(
	POSITION	pos,			// I  :sʒu [-] (-) :-
	CString&	strAdd			// I  :}s [-] (-) :-
)
{
	// Fts쐬
	CEmphasisLine	Line;
	{
		Line.SetString( strAdd );

		// \F
		{
			// PsÕ[V𔽉f
			POSITION	posPrev;
			if( pos == NULL )
			{
				posPrev = m_lststrEditz.GetTailPosition();
			}
			else
			{
				posPrev = pos;
				m_lststrEditz.GetPrev( posPrev );
			}
			if ( posPrev != NULL )
			{
				CEmphasisLine& EmphasisLine = m_lststrEditz.GetAt( posPrev );
				Line.SetEmphasisPrevRelation( EmphasisLine.GetEmphasisNextContinue() );
			}
		}
	}

	// ɑ}
	if( pos != NULL )
	{
		m_lststrEditz.InsertBefore( pos, Line );
	}
	else
	{
		m_lststrEditz.AddTail( Line );
	}

	return( TRUE );
}


/*-----------------------------------------------------------------------------
[]	I͈͍폜
[@\]	I͈͂폜B
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void	CShitarabianDoc::SelectedDelete()
{
	CSelection*	pSelection = GetSelection();

	if ( pSelection->IsSelected() )
	{
		switch ( GetOperationMode() )
		{
		case OperationBoxSelect:
			GetBoxSelection()->BoxClear();
			break;

		case OperationFloating:
			break;

		case OperationNormal:
		default:
			{
				// Undo̓o^
				CCommandDelete	cmdDelete;

				// I͈͍폜
				cmdDelete.SetAttribute(
					pSelection->GetSelectedStartRow(),
					pSelection->GetSelectedStartColumn(),
					pSelection->GetSelectedEndRow(),
					pSelection->GetSelectedEndColumn()
				);
				cmdDelete.Execute( this );

				CCommandManager*	pCmd = CCommandManager::GetInstance();
				pCmd->Add( cmdDelete );
			}
			break;
		}

		pSelection->SetSelectedNutral();
	}
}


/*-----------------------------------------------------------------------------
[]	I擾
[@\]	샂[hɉI擾B
[ߒl]	CSelection*		I [-] (-)
[l]	Ȃ
-----------------------------------------------------------------------------*/
CSelection*		CShitarabianDoc::GetSelection()
{

	switch ( GetOperationMode() )
	{
	case OperationROI:
		return( GetROISelection() );
		break;

	case OperationBoxSelect:
		return( GetBoxSelection() );
		break;

	case OperationFloating:
		return( GetFloatingSelection() );
		break;

	case OperationNormal:
	default:
		return( GetNormalSelection() );
		break;
	}
}


/*-----------------------------------------------------------------------------
[]	ʏI擾
[@\]	ʏI擾B
[ߒl]	CSelection*		I [-] (-)
[l]	Ȃ
-----------------------------------------------------------------------------*/
CSelection*		CShitarabianDoc::GetNormalSelection()
{
	static CSelection	sNormalSelection;
	return( &sNormalSelection );
}


/*-----------------------------------------------------------------------------
[]	ROII擾
[@\]	ROII擾B
[ߒl]	CROISelection*		I [-] (-)
[l]	Ȃ
-----------------------------------------------------------------------------*/
CROISelection*	CShitarabianDoc::GetROISelection()
{
	static CROISelection	sROISelection;

	return( &sROISelection );
}


/*-----------------------------------------------------------------------------
[]	BoxI擾
[@\]	BoxI擾B
[ߒl]	CBoxSelection*		I [-] (-)
[l]	Ȃ
-----------------------------------------------------------------------------*/
CBoxSelection*	CShitarabianDoc::GetBoxSelection()
{
	static CBoxSelection	sBoxSelection;

	return( &sBoxSelection );
}


/*-----------------------------------------------------------------------------
[]	t[eBO擾
[@\]	t[eBO擾B
[ߒl]	CFloatingSelection*		t[eBO [-] (-)
[l]	Ȃ
-----------------------------------------------------------------------------*/
CFloatingSelection*	CShitarabianDoc::GetFloatingSelection()
{
	static CFloatingSelection	sFloatingSelection;

	return( &sFloatingSelection );
}


/*-----------------------------------------------------------------------------
[]	uJvnh
[@\]	CDocument::OnOpenDocument()̃wvQƁB
[ߒl]	BOOL	 [-] (TRUE:AFALSE:s)
[l]	Ȃ
-----------------------------------------------------------------------------*/
BOOL CShitarabianDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	// ݒtH_̑݊mF
	{
		CFileStatus		tStatus;
		BOOL	bExists;
		bExists = CFile::GetStatus(
			lpszPathName,
			tStatus
		);
		if (!bExists) 
		{
			// ݂ȂΌxēǂݍ܂Ȃ
			CString	strMsg;
			strMsg = CString("t@C\n") + lpszPathName + "\n݂܂B";
			AfxMessageBox( strMsg );
			return( FALSE );
		}
	}

	// 炩ߍsXg
	m_lststrEditz.RemoveAll();

	//  (3199) BGN 2003.10.24 (dincom) Lt@CɊJ
	//  oridinal BGN
	// VACYɂǂݍ
	//if (!CDocument::OnOpenDocument(lpszPathName))
	//{
		// ǂݍ݂ɎsA傤Ȃ̂ŕNA
	//	m_lststrEditz.RemoveAll();
	//}
	//  oridinal END
	if (!OnOpenDocumentCore(lpszPathName))
	{
		// ǂݍ݂ɎsA傤Ȃ̂ŕNA
		m_lststrEditz.RemoveAll();
	}
	//  (3199) END

	// Ps݂Ȃ̂ł΂PsĂ
	if ( m_lststrEditz.GetCount() == 0 )
	{
		CEmphasisLine	NewLine;
		NewLine.SetString( "" );
		m_lststrEditz.AddTail( NewLine );
	}
	// XVꂽققق`
	m_bModified = TRUE;

	// IԂ̏
	GetSelection()->SetSelectedNutral();

	// }[LO͉Ă
	m_nMark = 0;

	// Lbgʒȕ
	CCommandCaret	cmdCaret;
//  (3146) BGN 2003.12.06 (moralog) CMainFrame::OnShowWindow)ֈړ
//  oridinal BGN
//  (3146) BGN 2003.11.08 (moralog) ǂݍݎAIvV𔽉f
//  oridinal BGN
	cmdCaret.SetAttribute( 0x00, 0, 0 );
//  oridinal END
/*
	long	idxRow( 0 );
	long	idxColumn( 0 );
	//  oridinal BGN
	//idxRow = atol(::GetCommandtailOption( ::GetString( IDS_OPTION_ROW ) ));
	//  oridinal END

	//  (3146) BGN 2003.11.21 (dincom) ős𒴂Ȃu
	static BOOL sbFirstOpen = TRUE;

	if ( sbFirstOpen )
	{
		sbFirstOpen = FALSE;

		idxRow = atol(::GetCommandtailOption( ::GetString( IDS_OPTION_ROW ) )) -1;
		if( idxRow > GetLineCount() )
		{
			idxRow = GetLineCount() - 1;
		}
		else if( idxRow < 0 )
		{
			idxRow = 0;
		}
		//  (3146) END
		idxColumn = atol(::GetCommandtailOption( ::GetString( IDS_OPTION_COLUMN ) ));
	}
	cmdCaret.SetAttribute( 0x00, idxRow, idxColumn );
//  (3146) END
*/
//  oridinal END
//  (3146) END
	cmdCaret.Execute( this );

	// R}hXg̔j
	CCommandManager::GetInstance()->RemoveAll();

	SetMainView( NULL );
	POSITION pos = GetFirstViewPosition();
	if ( pos != NULL )
	{
		SetMainView( (CShitarabianView*)GetNextView(pos) );
		GetMainView()->SetPrevVisibleRow(
			0,
			0
		);
		GetMainView()->ResetHScroll();
		GetMainView()->ScrollToCaret();
	}

	// XVʒm
	CShitarabianPlugInManager::GetInstance()->OnEdit(
		this
	);

	return TRUE;
}

//  (3199) BGN 2003.11.08 (dincom) VKǉ
/*-----------------------------------------------------------------------------
[]	hLgI[v
[@\]	CDocument::OnOpenDocument()̃wvQƁB
[ߒl]	BOOL	 [-] (TRUE:AFALSE:s)
[l]	(3199) 2003-10-24	 ֐t(dincom)
		NXOnOpenDocumentJX^}CŶߐVKǉB
-----------------------------------------------------------------------------*/
BOOL CShitarabianDoc::OnOpenDocumentCore(LPCTSTR lpszPathName)
{
	if (IsModified())
		TRACE0("Warning: OnOpenDocument replaces an unsaved document.\n");

	CFileException fe;
	CFile* pFile = GetFile(lpszPathName,
		CFile::modeRead|CFile::shareDenyWrite, &fe);

	if (pFile == NULL)
	{
		//LᔽłɊJ
		if( ::AfxMessageBox( _T("̃AvP[Vŏ㏑֎~Ă܂B\nJ܂H") , MB_OKCANCEL ) == IDOK )
		{
			pFile = GetFile( lpszPathName, CFile::modeRead|CFile::shareDenyNone , &fe);
		}
		else
		{
			return FALSE;
		}
	}

	DeleteContents();
	SetModifiedFlag();  // dirty during de-serialize

	CArchive loadArchive(pFile, CArchive::load | CArchive::bNoFlushOnDelete);
	loadArchive.m_pDocument = this;
	loadArchive.m_bForceFlat = FALSE;
	TRY
	{
		CWaitCursor wait;
		if (pFile->GetLength() != 0)
			Serialize(loadArchive);     // load me
		loadArchive.Close();
		ReleaseFile(pFile, FALSE);
	}
	CATCH_ALL(e)
	{
		ReleaseFile(pFile, TRUE);
		DeleteContents();   // remove failed contents

		TRY
		{
			ReportSaveLoadException(lpszPathName, e,
				FALSE, AFX_IDP_FAILED_TO_OPEN_DOC);
		}
		END_TRY
		DELETE_EXCEPTION(e);
		return FALSE;
	}
	END_CATCH_ALL

	SetModifiedFlag(FALSE);     // start off with unmodified

	return TRUE;
}
//  (3199) END

/*-----------------------------------------------------------------------------
[]	ݒ
[@\]	EBhE^Cgɕ\镶ݒ肷B
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CShitarabianDoc::SetTitle(
	LPCTSTR lpszTitle		// I  : [-] (-)
) 
{
	// warning C4100:x̖
	lpszTitle;

	// ^Cg\̐ݒ
	CString		strTitle;
	CString		strFilePath = GetPathName();

	if ( strFilePath.IsEmpty() )
	{
		strFilePath = _T( "ij" );
	}

	if ( IsModified() )
	{
		strTitle.Format( _T("%s [XV]"), strFilePath );
	}
	else
	{
		strTitle.Format( _T("%s"), strFilePath );
	}

	CDocument::SetTitle( strTitle );
}


/*-----------------------------------------------------------------------------
[]	sCfNX̍\z
[@\]	sCfNX̍\zB
[ߒl]	Ȃ
[l]	Xgŕێsf[^AzC[WŃANZX邽߂
		CfNX\zBisf[^ւ̃|C^zŎj
-----------------------------------------------------------------------------*/
void CShitarabianDoc::PrepareIndex()
{
	if ( m_paIndex != NULL )
	{
		delete m_paIndex;
		m_paIndex = NULL;
	}

	// CfNXp̔zm
	long	nRow = m_lststrEditz.GetCount();
	m_paIndex = new POSITION[ nRow ];

	POSITION	pos;
	pos = m_lststrEditz.GetHeadPosition();
	long	idxRow;
	for( idxRow=0 ; idxRow<nRow ; idxRow++ )
	{
		m_paIndex[ idxRow ] = pos;
		m_lststrEditz.GetNext( pos );
	}
}


/*-----------------------------------------------------------------------------
[]	ĕ`
[@\]	ĕ`揈B
[ߒl]	Ȃ
[l]	XVv̏oĂ镔̂ݕ`悷B
-----------------------------------------------------------------------------*/
void CShitarabianDoc::ReDraw(
	CShitarabianView*	pView		// I  :Ώۃr[ [-] (-) :NULL
)
{
	// ^Cg\̐ݒ
	SetTitle( "" );

	if ( pView == NULL )
	{
		// SyC\
		CMainFrame*		pFrame = (CMainFrame*)::AfxGetMainWnd();
		if ( pFrame != NULL )
		{
			CSplitterWnd*	pSplitter = pFrame->GetSplitter();

			int	nRow = pSplitter->GetRowCount();
			int	nColumn = pSplitter->GetColumnCount();

			if ( pSplitter != NULL )
			for ( int idxRow=0 ; idxRow<nRow ; idxRow++ )
			for ( int idxColumn=0 ; idxColumn<nColumn ; idxColumn++ )
			{
				CShitarabianView*	pWnd = (CShitarabianView*)(pSplitter->GetPane( idxRow, idxColumn ));
				if ( pWnd != NULL )
				{
					CDC*	pDC = NULL;
					pDC = pWnd->GetDC();	
					pWnd->OnPrepareDC( pDC, NULL );
					pWnd->DrawPage( pDC );
					pWnd->ReleaseDC( pDC );
				}
			}
		}
	}
	else
	{
		CDC*	pDC = NULL;
		pDC = pView->GetDC();	
		pView->OnPrepareDC( pDC, NULL );
		pView->DrawPage( pDC );
		pView->ReleaseDC( pDC );
	}
	m_idxUpdateStartRow = InitialRow;
	m_idxUpdateEndRow = InitialRow;
}


/*-----------------------------------------------------------------------------
[]	\XVJnsݒ
[@\]	\XVJns̐ݒB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void	CShitarabianDoc::SetUpdateStartRow(
	long idxUpdateStartRow		// I  :\XVJns [-] (-) :-
)
{
	switch( idxUpdateStartRow )
	{
	case InitialRow:
	case AllRow:
		m_idxUpdateStartRow = idxUpdateStartRow;
		break;

	default:
		if ( m_idxUpdateStartRow != InitialRow )
		{
			if ( idxUpdateStartRow < m_idxUpdateStartRow )
			{
				m_idxUpdateStartRow = idxUpdateStartRow;
			}
			else
			{
				switch( m_idxUpdateEndRow )
				{
				case InitialRow:
				case AllRow:
					break;

				default:
					if ( idxUpdateStartRow > m_idxUpdateEndRow )
					{
						m_idxUpdateEndRow = idxUpdateStartRow;
					}
				}
			}
		}
		else
		{
			m_idxUpdateStartRow = idxUpdateStartRow;
		}
		break;
	}

	POSITION pos = GetFirstViewPosition();
	while (pos != NULL)
	{
		CShitarabianView* pView = (CShitarabianView*)GetNextView(pos);
		pView->SetUpdateStartRow( m_idxUpdateStartRow );
	}
}


/*-----------------------------------------------------------------------------
[]	\XVIsݒ
[@\]	\XVIs̐ݒB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void	CShitarabianDoc::SetUpdateEndRow(
	long idxUpdateEndRow		// I  :\XVJns [-] (-) :-
)
{
	switch( idxUpdateEndRow )
	{
	case InitialRow:
	case AllRow:
		m_idxUpdateEndRow = idxUpdateEndRow;
		break;

	default:
		if ( m_idxUpdateEndRow == AllRow )
		{
			break;
		}

		if ( m_idxUpdateEndRow == InitialRow )
		{
			m_idxUpdateEndRow = idxUpdateEndRow;
			break;
		}

		m_idxUpdateEndRow = max( idxUpdateEndRow, m_idxUpdateEndRow );

		// X^[gςKvH
		{
			switch( m_idxUpdateStartRow )
			{
			case InitialRow:
			case AllRow:
				break;

			default:
				if ( idxUpdateEndRow < m_idxUpdateStartRow )
				{
					m_idxUpdateStartRow = idxUpdateEndRow;
				}
				break;
			}
		}
		break;
	}

	POSITION pos = GetFirstViewPosition();
	while (pos != NULL)
	{
		CShitarabianView* pView = (CShitarabianView*)GetNextView(pos);
		pView->SetUpdateEndRow( m_idxUpdateEndRow );
	}
}


/*-----------------------------------------------------------------------------
[]	XVԎ擾
[@\]	XVꂽ𓾂B
[ߒl]	BOOL	XV [-] (TRUE:XVꂽAFALSE:XV)
[l]	Ȃ
-----------------------------------------------------------------------------*/
BOOL	CShitarabianDoc::IsModify(
	long idxRow			// I  :s [-] (-)
)
{
	POSITION	pos;
	pos = GetPosition( idxRow );
	if( pos != NULL )
	{
		return( m_lststrEditz.GetAt( pos ).IsModify() );
	}
	return( FALSE );
}


/*-----------------------------------------------------------------------------
[]	}[LOgO
[@\]	s}[NgOB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CShitarabianDoc::Mark(
	int		idxLine			// I  :s [-] (-)			  
) 
{
	BOOL	bMarking = !IsMark( idxLine );
	SetMark( idxLine, bMarking );
	SetUpdateStartRow( idxLine );

	if ( bMarking )
	{
		m_nMark ++ ;
	}
	else
	{
		m_nMark -- ;
	}
}


/*-----------------------------------------------------------------------------
[]	ũ}[Nsցv
[@\]	̃}[NsփWvB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CShitarabianDoc::NextMark() 
{
	int		iCurrentRow = GetCaretRow();

	int idxLine;
	for( idxLine=iCurrentRow+1 ; idxLine<GetLineCount() ; idxLine++ )
	{
		if ( IsMark( idxLine ) )
		{
			SetCaretRow( idxLine );
			return;
		}
	}
	for(idxLine=0 ; idxLine<iCurrentRow ; idxLine++ )
	{
		if ( IsMark( idxLine ) )
		{
			SetCaretRow( idxLine );
			return;
		}
	}
}


/*-----------------------------------------------------------------------------
[]	uÕ}[Nsցv
[@\]	Õ}[NsփWvB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CShitarabianDoc::PrevMark() 
{
	int		iCurrentRow = GetCaretRow();

	int idxLine;
	for( idxLine=iCurrentRow-1 ; idxLine>=0 ; idxLine-- )
	{
		if ( IsMark( idxLine ) )
		{
			SetCaretRow( idxLine );
			return;
		}
	}
	for(idxLine=GetLineCount() ; idxLine>iCurrentRow ; idxLine-- )
	{
		if ( IsMark( idxLine ) )
		{
			SetCaretRow( idxLine );
			return;
		}
	}
}


/*-----------------------------------------------------------------------------
[]	uS}[Nv
[@\]	S}[NsB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CShitarabianDoc::DeMark() 
{
	int idxLine;
	for( idxLine=0 ; idxLine<GetLineCount() ; idxLine++ )
	{
		SetMark( idxLine, FALSE );
	}

	m_nMark = 0;
}


/*-----------------------------------------------------------------------------
[]	}[Nݒ
[@\]	s̃}[NԂݒ肷B
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void	CShitarabianDoc::SetMark(
	long	idxRow,			// I  :s [-] (-) :-
	BOOL	bMark			// I  :}[N [-] (TRUE:}[NsAFALSE:ʏs) :-
){
	POSITION	pos;
	pos = GetPosition( idxRow );
	if( pos != NULL )
	{
		m_lststrEditz.GetAt( pos ).SetMark( bMark );
	}
}

/*-----------------------------------------------------------------------------
[]	s}[N擾
[@\]	s̃}[NԂ擾B
[ߒl]	BOOL	}[N [-] (TRUE:}[NsAFALSE:ʏs)
[l]	Ȃ
-----------------------------------------------------------------------------*/
BOOL	CShitarabianDoc::IsMark(
	long idxRow			// I  :s [-] (-) :-
)
{
	POSITION	pos;
	pos = GetPosition( idxRow );
	if( pos != NULL )
	{
		return( m_lststrEditz.GetAt( pos ).IsMark() );
	}
	return( FALSE );
}


/*-----------------------------------------------------------------------------
[]	ũ}[Nsցv
[@\]	̃}[NsփWvB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CShitarabianDoc::NextModify() 
{
	int		iCurrentRow = GetCaretRow();

	int idxLine;
	for( idxLine=iCurrentRow+1 ; idxLine<GetLineCount() ; idxLine++ )
	{
		if ( IsModify( idxLine ) )
		{
			SetCaretRow( idxLine );
			return;
		}
	}
	for(idxLine=0 ; idxLine<iCurrentRow ; idxLine++ )
	{
		if ( IsModify( idxLine ) )
		{
			SetCaretRow( idxLine );
			return;
		}
	}
}


/*-----------------------------------------------------------------------------
[]	uÕ}[Nsցv
[@\]	Õ}[NsփWvB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CShitarabianDoc::PrevModify() 
{
	int		iCurrentRow = GetCaretRow();

	int idxLine;
	for( idxLine=iCurrentRow-1 ; idxLine>=0 ; idxLine-- )
	{
		if ( IsModify( idxLine ) )
		{
			SetCaretRow( idxLine );
			return;
		}
	}
	for(idxLine=GetLineCount() ; idxLine>iCurrentRow ; idxLine-- )
	{
		if ( IsModify( idxLine ) )
		{
			SetCaretRow( idxLine );
			return;
		}
	}
}


/*-----------------------------------------------------------------------------
[]	}`JlLbgJʒu擾
[@\]	LbguJ擾B
[ߒl]	long		Jʒu [LbgJ] (-)
[l]	}`JXLbvāAJʒuԂB
		idxCaretColumn}`Jł΁A
		}`J̒̃JԂB
-----------------------------------------------------------------------------*/
long CShitarabianDoc::MultiColumnSkip(
	long			idxCaretRow,		// I  :s [-] (-) :-
	long			idxCaretColumn		// I  :J [-] (-) :-
)
{
	CUnicoder*	pUnicoder = CUnicoder::GetInstance();
	if ( pUnicoder->GetEnable() )
	{
		// }`JXLbv
		CEmphasisLine*	pEmphasisLine = GetEmphasisLine( idxCaretRow );
		if ( pEmphasisLine != NULL )
		{
			long	lPixelX = pEmphasisLine->CaretColumnToPixel( idxCaretColumn );
// please! ČH
			// \ƂXWωJT
			long	nColumn = pEmphasisLine->GetColumnCount();
			for( idxCaretColumn++ ; idxCaretColumn<=nColumn ; idxCaretColumn++ )
			{
				if ( lPixelX != pEmphasisLine->CaretColumnToPixel( idxCaretColumn ) )
				{
					return( idxCaretColumn-1 );
					break;
				}
			}
			return( nColumn );
		}
		// ws擾łȂ
		ASSERT( FALSE );
		return( 0 );
	}
	// Unicode\LłȂƂ̓}`J݂Ȃ̂ŉȂ
	return( idxCaretColumn );
}


/*-----------------------------------------------------------------------------
[]	\F͏񏉊
[@\]	\F͏̏B
[ߒl]	Ȃ
[l]	\Fݒ肪ύXꂽƂɎgpB
-----------------------------------------------------------------------------*/
void CShitarabianDoc::ReflectEmphasis()
{
	// s\F̍č\z
	CGeneralSetting::GetInstance()->GetEmphasisDefine()->MultiLineEmphasisStarterPrepare();

	// sƂ̐F̏
	POSITION	pos;
	pos = m_lststrEditz.GetHeadPosition();
	while( pos != NULL )
	{
		CEmphasisLine&	Line = m_lststrEditz.GetNext( pos );
		Line.ResetWholeEmphasis();
	}	
}


/*-----------------------------------------------------------------------------
[]	Cr[擾
[@\]	Cr[擾B
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
CShitarabianView*	CShitarabianDoc::GetMainView()
{
	// XvbgEBhȆɂViewĂꍇA
	// VLView擾Ȃ
	if ( m_pviewMain != NULL )
	if ( !::IsWindow( m_pviewMain->m_hWnd ) )
	{
		SetMainView( NULL );
		POSITION pos = GetFirstViewPosition();
		if ( pos != NULL )
		{
		  SetMainView( (CShitarabianView*)GetNextView(pos) );
		} 
	}
	return( m_pviewMain );
}


/*-----------------------------------------------------------------------------
[]	s\
[@\]	s\̉͂sAȍ~̍sɔfB
[ߒl]	BOOL	 [-] (TRUE:AFALSE:Ȃ)
[l]	s̒ǉEҏWsƂɃR[邱ƁB
-----------------------------------------------------------------------------*/
BOOL CShitarabianDoc::AnalizeMultiLineEmphasis(
	CEmphasisDefine*	pEmphasisDefine,	// I  :\Fݒ [-] (-) :-
	int					iRow				// I  :s [-] (-) :-
)
{
	// s\͂~̂Ƃ̓XLbv
	if ( !CEmphasisLine::GetAnalizeMultiLineEmphasisEnable() )
	{
		return( TRUE );
	}

	// s̑݊mF
	CEmphasisLine* pLine =GetEmphasisLine( iRow );
	if ( pLine == NULL )
	{
		return( FALSE );
	}

	// słɉ͂Ă΃XLbv
	if ( pLine->GetMultiLineEmphasisAnalized() )
	{
		return( FALSE );
	}

	// ̍s܂ŕs\F͂ςł邱ƂO
	// O̍sɂ̂ڂĒׂ
	if ( iRow > 0 )
	if ( !GetEmphasisLine( iRow-1 )->GetMultiLineEmphasisAnalized() )
	{
		// fobOɈٕςm邽߂̃`FbNB
		ASSERT( FALSE );
	}

	SetUpdateStartRow( iRow );

	// s\F͂łȂΉ͂
	BOOL	bContinue = TRUE;
	while( bContinue )
	{
		if ( iRow >= GetLineCount() )
		{
			break;
		}

		// s̊ȈՉ́is\F̂݉́j
		if ( GetEmphasisLine( iRow )->GetEmphasisPrevRelation() != EMPHASIS_TEXT )
		{
			// s\JzĂꍇ
			// ǂŌJzÎAčĊĴ킩Ȃ̂
			// ܂߂ɉ͂B
			GetEmphasisLine( iRow )->Analize(
				NULL,
				pEmphasisDefine
			);
		}
		else
		{
			// JzłȂieLXg\FŎn܂ꍇj
			// s\Jn邩͂
			GetEmphasisLine( iRow )->ResetWholeEmphasis();
			GetEmphasisLine( iRow )->AnalizeStringMultiLineEmphasis(
				NULL,
				pEmphasisDefine
			);
		}

		// s\芮
		GetEmphasisLine( iRow )->SetMultiLineEmphasisAnalized( TRUE );

		// s\ݒ̍sȍ~ɔf
		short	iNextContinue = GetEmphasisLine( iRow )->GetEmphasisNextContinue();

		if ( !pEmphasisDefine->GetItemz()[ iNextContinue ].GetTerminator().IsEmpty() )
		{
			// s\̂ŁAȍ~̍sɓKp
			int		idxRelationRow;
			for( idxRelationRow=iRow+1 ; idxRelationRow<GetLineCount() ; idxRelationRow++ )
			{
				// Jz\ݒ肪
				// uO̍s̋\Jzvɍvs܂ŒTs
				if( GetEmphasisLine( idxRelationRow )->GetEmphasisPrevRelation()
					== iNextContinue
				)
				{
					// uO̍s̋\Jzv
					// ߂Jz\ݒƓȂ̂ŉ߂ĉ͂KvȂ
					bContinue = FALSE;
					break;
				}
				else
				{
					GetEmphasisLine( idxRelationRow )->SetEmphasisPrevRelation( iNextContinue );

					// Jz\ݒ̏I[
					int	idxTerminator = GetEmphasisLine( idxRelationRow )->SerchEmphasisTerminator(
						pEmphasisDefine,
						iNextContinue
					);

					if( idxTerminator > 0 )
					{
						// I[̂ŌJz͂̍sŏIB
						// A̍sɕs\F̊JnȂVɕs\F͂KvB
						GetEmphasisLine( idxRelationRow )->SetMultiLineEmphasisAnalized( FALSE );
						break;
					}
					// ̍sKvA
					GetEmphasisLine( idxRelationRow )->SetEmphasisNextContinue( iNextContinue );
				}

				GetEmphasisLine( idxRelationRow )->ResetDetailEmphasis();
				GetEmphasisLine( idxRelationRow )->SetMultiLineEmphasisAnalized( TRUE );
			}
			iRow = idxRelationRow;
		}
		else
		{
			// s\Ȃ̂ŁAȍ~̍šJz
			int		idxRelationRow;
			for( idxRelationRow=iRow+1 ; idxRelationRow<GetLineCount() ; idxRelationRow++ )
			{
				if( GetEmphasisLine( idxRelationRow )->GetEmphasisPrevRelation()
					== EMPHASIS_TEXT
				)
				{
					// ƂƌJzĂȂs𔭌̂
					// ȍ~̍sɂďKv͂Ȃ
					bContinue = FALSE;
					break;
				}
				else	
				{
					// JzāAӂ[̃eLXg\FŊJnsƂ
					GetEmphasisLine( idxRelationRow )->SetEmphasisPrevRelation( EMPHASIS_TEXT );
					// AVɂ̍s̕s\F͂KvB
					GetEmphasisLine( idxRelationRow )->ResetWholeEmphasis();
					GetEmphasisLine( idxRelationRow )->SetMultiLineEmphasisAnalized( TRUE );
					break;
				}
			}
			iRow = idxRelationRow;
		}
	}
	SetUpdateEndRow( iRow );

	return( TRUE );
}


/*-----------------------------------------------------------------------------
[]	\F͏ڍ׏̏
[@\]	\F͏ڍ׏B
[ߒl]	Ȃ
[l]	\Fݒ̈ꕔύXꂽƂɕ\F͂̍ď̂߂ɎgpB
		񂪕ύXꂽƂB
-----------------------------------------------------------------------------*/
void CShitarabianDoc::UpdateEmphasis()
{
	// sƂ̐F̏
	POSITION	pos;
	pos = m_lststrEditz.GetHeadPosition();
	while( pos != NULL )
	{
		CEmphasisLine&	Line = m_lststrEditz.GetNext( pos );
		Line.ResetDetailEmphasis();
	}	
}


/*-----------------------------------------------------------------------------
[]	\F
[@\]	ws̕\F͂sB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CShitarabianDoc::AnalizeEmphasisLinez(
	const long	idxStart,		// I  :Jns [-] (-) :-
	const long	idxEnd			// I  :Is [-] (-) :-
)
{
	CMainFrame*		pFrame = (CMainFrame*)::AfxGetMainWnd();
	CProgressDlg*	pProgress = pFrame->GetProgressDlg();
	pProgress->Show();

	int		idxLine;
	for( idxLine=idxStart ; idxLine<=idxEnd ; idxLine++ )
	{
		// ܂A܂镡s\F𖳌ɂ
		CEmphasisLine*	pLine = GetEmphasisLine( idxLine );
		if ( pLine != NULL )
		{
			pLine->SetMultiLineEmphasisAnalized( FALSE );
		}
	}

	// Jz\F̍č\z
	for( idxLine=idxStart; idxLine<idxEnd ; idxLine++ )
	{
		pProgress->NotifyProgress( (idxLine*100)/(idxEnd-idxStart+1) );

		AnalizeMultiLineEmphasis(
			CGeneralSetting::GetInstance()->GetEmphasisDefine(),
			idxLine
		);
	}

	pProgress->Hide();
}

/*-----------------------------------------------------------------------------
[]	\F
[@\]	ws̕\F͂sB
[ߒl]	Ȃ
[l]	Ȃ
-----------------------------------------------------------------------------*/
void CShitarabianDoc::AnalizeEmphasisLinez(
	const CDWordArray& adwLinez		// I  :sQ [-] (-) :-
)
{
	CMainFrame*		pFrame = (CMainFrame*)::AfxGetMainWnd();
	CProgressDlg*	pProgress = pFrame->GetProgressDlg();
	pProgress->Show();

	int		idxLine;
	for( idxLine=0 ; idxLine<adwLinez.GetSize() ; idxLine++ )
	{
		// ܂A܂镡s\F𖳌ɂ
		CEmphasisLine*	pLine = GetEmphasisLine( adwLinez[idxLine] );
		if ( pLine != NULL )
		{
			pLine->SetMultiLineEmphasisAnalized( FALSE );
		}
		else
		{
			TRACE( "%d\n",adwLinez[idxLine]);
			ASSERT( FALSE );
		}
	}

	// Jz\F̍č\z
	for( idxLine=0 ; idxLine<adwLinez.GetSize() ; idxLine++ )
	{
		pProgress->NotifyProgress( (idxLine*100)/adwLinez.GetSize() );

		AnalizeMultiLineEmphasis(
			CGeneralSetting::GetInstance()->GetEmphasisDefine(),
			adwLinez[idxLine]
		);
	}

	pProgress->Hide();
}


/*-----------------------------------------------------------------------------
[]	s̊g
[@\]	wʒu܂ōsgB
[ߒl]	Ȃ
[l]	t[J[\[hpB
-----------------------------------------------------------------------------*/
void CShitarabianDoc::AppendRow(
	long		idxRow		// I  :s [-] (-) :-
)
{
	// s݂Ȃ΂܂ō
	if ( idxRow >= GetLineCount() )
	{
		// ɍs}
		int nRow = GetLineCount()-1;
		int nColumn = GetEmphasisLine(nRow)->GetColumnCount();

		CString		strAdd;
		long	idxLine;
		for( idxLine=0 ; idxLine<idxRow-nRow ; idxLine++ )
		{
			strAdd += ReturnChar();
		}

		// sǉ
		CCommandInput		cmdInput;
		CCommandManager*	pCmd = CCommandManager::GetInstance();
		cmdInput.SetAttribute( strAdd, nRow, nColumn );
		cmdInput.Execute( this );
		pCmd->Add( cmdInput );
	}
}

/*-----------------------------------------------------------------------------
[]	J̊g
[@\]	wʒu܂ŃJgB
[ߒl]	Ȃ
[l]	t[J[\[hpB
-----------------------------------------------------------------------------*/
void CShitarabianDoc::AppendColumn(
	long		idxRow,			// I  :s [-] (-) :-
	long		lXColummn		// I  :Jʒu [pixel] (-) :-
)
{
	CDC*		pDC = NULL;
	pDC = GetMainView()->GetDC();
	if ( pDC != NULL )
	{
	// JȂ΃J
		CString		strPad;
		CEmphasisLine*	pEmphasisLine = GetEmphasisLine( idxRow );
		if ( pEmphasisLine != NULL )
		{
			int		iBlankStartX;
			int		iBlankStartColumn;
			CEmphasisLine*	pEmphasisLine = GetEmphasisLine( idxRow );
			// Is̋󔒊JnʒuT
			{
				CWhitespaceDefine*	pWhitespace = CGeneralSetting::GetInstance()->GetWhitespace();
				CArray<TWhiteSpace, TWhiteSpace&>*	paCharz = pWhitespace->GetCharz();

				// }W̃Lbgʒu擾
				if ( pEmphasisLine != NULL )
				{
					// 獶֑BOpfBOJnJ{B
					CPadding	Padding;
					iBlankStartColumn = Padding.PrevWhiteSpaceColumn(
						*(::GetDocument()->GetLine( idxRow )),
						pEmphasisLine->GetColumnCount(),
						*paCharz
					);
					iBlankStartX = pEmphasisLine->CaretColumnToPixel(
						iBlankStartColumn
					);
				}
				else
				{
					// ݂Ȃsɑ΂Ă̓pfBOłȂɂ
					ASSERT( FALSE );
					return;
				}
			}

			long	lNewLength = max( 0, lXColummn );
			if ( iBlankStartX < lNewLength )
			{
				CPadding	Padding;
				long	iGap;
				iGap = Padding.Padding(
					pDC,
					lNewLength - iBlankStartX,
					strPad,
					*( CGeneralSetting::GetInstance()->GetWhitespace()->GetCharz() ),
					TRUE
				);

				// s̍XV
				{
					CCommandMultiEdit		cmdEdit;

					// s̓e폜
					if (pEmphasisLine->GetColumnCount() > 0 )
					{
						CCommandDelete	cmdDelete;
						cmdDelete.SetAttribute(
							idxRow,
							iBlankStartColumn,
							idxRow,
							pEmphasisLine->GetColumnCount()
						);
						cmdEdit.Add( cmdDelete );
					}

					// Iʒuɕ}
					CCommandInput	cmdInput;
					cmdInput.SetAttribute(
						strPad,
						idxRow,
						GetEmphasisLine(idxRow)->GetColumnCount()
					);
					cmdEdit.Add( cmdInput );

					cmdEdit.Execute( this );
					CCommandManager*	pCmd = CCommandManager::GetInstance();
					pCmd->Add( cmdEdit );
				}
			}
		}
	}
	GetMainView()->ReleaseDC( pDC );
}